---
title: Using HTML sections and outlines
slug: Web/Guide/HTML/Using_HTML_sections_and_outlines
tags:
  - Advanced
  - Example
  - Guide
  - HTML
  - HTML5
  - Outlines
  - Overview
  - Sections
  - Web
---
<div>{{HTMLSidebar}}</div>

<div class="warning">
<p><strong>Important</strong>: There are no implementations of the proposed outline algorithm in web browsers nor assistive technology; it was never part of a final W3C specification. Therefore the <a href="https://www.w3.org/TR/html5/sections.html#outline">outline</a> algorithm <em>should not be used</em> to convey document structure to users. Authors are advised to use heading <a href="https://www.w3.org/TR/html5/sections.html#rank">rank</a> (<code><a href="https://www.w3.org/TR/html5/sections.html#the-h1-h2-h3-h4-h5-and-h6-elements">h1</a></code>-<code><a href="https://www.w3.org/TR/html5/sections.html#the-h1-h2-h3-h4-h5-and-h6-elements">h6</a></code>) to convey document structure.</p>
</div>

<p>The HTML5 specification introduced several semantic sectioning elements to help organize the structure of documents. Semantic sectioning elements are specifically designed to communicate structural meaning to browsers and other technologies interpreting the document on behalf of users, such as screen readers and voice assistants.</p>

<p>Semantic sectioning elements clarify the larger-scale structures within a document. They are intended to enhance the limited semantics of earlier versions of HTML, which included only the <code>&lt;div&gt;</code> tag as a generic mechanism for grouping related content. For example, <code>&lt;div class="navigation"&gt;</code> does not suggest any meaning about its content to a browser; only a human reading the HTML source can divine the meaning of a class like <code>navigation</code>. By contrast, the <code>&lt;nav&gt;</code> sectioning element more clearly describes to browsers and other devices the content contained: links or other navigational structures to help users move through and understand where they are in a site's or page's content.</p>

<p>New semantic elements were added to HTML5 to improve and clarify the sectioning of websites into meaningful areas of content. It is important for developers to use these semantic elements in line with their intended purposes. Many accessibility tools as well as reader views provided by some browsers rely on semantic sectioning elements. So don't swap out an existing tangle of <code>&lt;div&gt;</code> elements for a bunch of <code>&lt;section&gt;</code> elements.</p>

<h2 id="Section_Elements_in_HTML5">Section Elements in HTML5</h2>

<ul>
 <li><strong>HTML Navigational Element</strong> ({{HTMLElement("nav")}}) defines a section that contains navigation links that appear often on a site. You can have primary and secondary menus, but you cannot nest a <code>&lt;nav&gt;</code> element inside another <code>&lt;nav&gt;</code> element.</li>
 <li><strong>HTML Article Element</strong> ({{HTMLElement("article")}}) defines a piece of self-contained content. It does not refer to the main content alone and can be used for comments and widgets.</li>
 <li><strong>HTML Section Element</strong> ({{HTMLElement("section")}}) defines a section of a document to indicate a related grouping of semantic meaning. It makes sense to use the section element to provide extra context for the parent element.</li>
 <li><strong>HTML Aside Element</strong> ({{HTMLElement("aside")}}) defines a section that, though related to the main element, doesn't belong to the main flow, like an explanation box or an advertisement. The aside element has its own outline, but doesn't belong to the main one.</li>
</ul>

<h3 id="Other_Semantic_HTML_elements_used_in_Sectioning">Other Semantic HTML elements used in Sectioning</h3>

<ul>
 <li><strong>HTML Body Element</strong> ({{HTMLElement("body")}}) defines all the content of a document. It contains all the content and HTML tags.</li>
 <li><strong>HTML Header Element</strong> ({{HTMLElement("header")}}) defines a page area that typically contains a logo, title, and navigation. The header can also be used inside other semantic elements such as <code>&lt;article&gt;</code> or <code>&lt;section&gt;</code>. A section header might contain the section's heading, author name, etc. {{HTMLElement("article")}}, {{HTMLElement("section")}}, {{HTMLElement("aside")}}, and {{HTMLElement("nav")}} can have their own {{HTMLElement("header")}}. Despite its name, the header is not necessarily positioned at the beginning of a page or section.</li>
 <li><strong>HTML Footer Element</strong> ({{HTMLElement("footer")}}) defines a page footer, which typically contains copyright or legal notices and sometimes some links. In the context of a section, a footer might contain the sectioned content's publication date, license information, etc. {{HTMLElement("article")}}, {{HTMLElement("section")}}, {{HTMLElement("aside")}}, and {{HTMLElement("nav")}} can have their own {{HTMLElement("footer")}}. Despite its name, the footer is not necessarily positioned at the end of a page or section.</li>
</ul>

<h2 id="How_Do_Sectional_Elements_Work">How Do Sectional Elements Work?</h2>

<pre> &lt;body&gt;
    &lt;header&gt;
      &lt;nav&gt;
        &lt;ul&gt;
          &lt;li&gt;&lt;a href="#"&gt;link&lt;/a&gt;&lt;/li&gt;
          &lt;li&gt;&lt;a href="#"&gt;link&lt;/a&gt;&lt;/li&gt;
          &lt;li&gt;&lt;a href="#"&gt;link&lt;/a&gt;&lt;/li&gt;
        &lt;/ul&gt;
      &lt;/nav&gt;
      &lt;h1&gt;
        Page Title
      &lt;/h1&gt;
    &lt;/header&gt;

    &lt;section&gt;
      &lt;h2&gt;
        My Blog Posts
      &lt;/h2&gt;
      &lt;article&gt;
        &lt;header&gt;
          &lt;p&gt;
            Article Title
          &lt;/p&gt;
        &lt;/header&gt;
        &lt;p&gt;
          content
        &lt;/p&gt;
      &lt;/article&gt;
      &lt;article&gt;
        &lt;header&gt;
          &lt;p&gt;
            Article Title
          &lt;/p&gt;
        &lt;/header&gt;
        &lt;p&gt;
          content
        &lt;/p&gt;
      &lt;/article&gt;
      &lt;aside&gt;
        &lt;p&gt;
          Author info
        &lt;/p&gt;
      &lt;/aside&gt;
    &lt;/section&gt;

    &lt;footer&gt;
      Copyright Info
    &lt;/footer&gt;
  &lt;/body&gt;</pre>

<h3 id="Nav_Element">Nav Element</h3>

<p>The <code>&lt;nav&gt;</code> element indicates a navigation block and should be used for major navigational menus.</p>

<pre>&lt;nav&gt;
  &lt;ul&gt;
    &lt;li&gt;&lt;a href="#"&gt;link&lt;/a&gt;&lt;/li&gt;
    &lt;li&gt;&lt;a href="#"&gt;link&lt;/a&gt;&lt;/li&gt;
  &lt;/ul&gt;
&lt;/nav&gt;</pre>

<h4 id="Nesting_Menus">Nesting Menus</h4>

<p>You do not nest <code>&lt;nav&gt;</code> elements. The <code>&lt;nav&gt;</code> can contain both primary and secondary menus.</p>

<pre>&lt;nav&gt;
  &lt;ul&gt;
    &lt;li&gt;&lt;a href="#"&gt;primary link&lt;/a&gt;&lt;/li&gt;
    &lt;li&gt;
      &lt;a href="#"&gt;primary link&lt;/a&gt;
      &lt;ul&gt;
        &lt;li&gt;&lt;a href="#"&gt;secondary link&lt;/a&gt;&lt;/li&gt;
        &lt;li&gt;&lt;a href="#"&gt;secondary link&lt;/a&gt;&lt;/li&gt;
      &lt;/ul&gt;
    &lt;/li&gt;
    &lt;li&gt;&lt;a href="#"&gt;primary link&lt;/a&gt;&lt;/li&gt;
  &lt;/ul&gt;
&lt;/nav&gt;</pre>

<h4 id="Collection_of_Links">Collection of Links</h4>

<p>Use the <code>&lt;nav&gt;</code> element only for site navigation menus. Collections of links such as social media profiles or a blogroll should not be wrapped in the <code>&lt;nav&gt;</code> element.</p>

<h4 id="HTML_Elements_in_&lt;nav&gt;">HTML Elements in &lt;nav&gt;</h4>

<p>While list elements are common for navigation they are not required. You can use other elements such as <code>&lt;p&gt;</code>.</p>

<h3 id="Article_Element">Article Element</h3>

<p>The <code>&lt;article&gt;</code> element indicates self-contained content, meaning that if you removed all the other HTML except the <code>&lt;article&gt;</code> element, the content would still make sense to a reader.</p>

<pre>&lt;article&gt;
  &lt;h1&gt;How to Become an MDN Contributor&lt;/h1&gt;
  &lt;p&gt;
    Do you want to help protect the web?....
  &lt;/p&gt;
&lt;/article&gt;</pre>

<h4 id="Nesting_Elements_Inside_an_Article">Nesting Elements Inside an Article</h4>

<p>The <code>&lt;article&gt;</code> element can have other semantic elements such as headers, asides, and footers. This is often useful if you want to add CSS selectors to the class property of the element to style the document.</p>

<pre>&lt;article&gt;
  &lt;header&gt;
    &lt;h1&gt;How to Become an MDN Contributor&lt;/h1&gt;
  &lt;/header&gt;
  &lt;p&gt;
    Do you want to help protect the web?....
  &lt;/p&gt;
  &lt;aside&gt;
    &lt;blockquote&gt;
      Amazing quote from article
    &lt;/blockquote&gt;
  &lt;/aside&gt;
  &lt;footer&gt;
    &lt;p&gt;
      Author info, publication date
    &lt;/p&gt;
  &lt;/footer&gt;
&lt;/article&gt;</pre>

<h4 id="Nesting_articles_and_sections">Nesting articles and sections</h4>

<p>Articles can be nested inside of sections and sections can be nested inside of articles. A book, for example, may be divided up into sections with related articles. Each of these articles could contain sections of related information.</p>

<pre>&lt;section&gt;
  &lt;h1&gt;Getting Involved&lt;/h1&gt;
  &lt;article&gt;
    &lt;header&gt;
      &lt;h2&gt;How to Become an MDN Contributor&lt;/h2&gt;
      &lt;p&gt;Do you want to help protect the web?....&lt;/p&gt;
    &lt;/header&gt;
    &lt;section&gt;
      &lt;h3&gt;Steps to Editing an Article&lt;/h3&gt;
    &lt;/section&gt;
    &lt;footer&gt;
      &lt;p&gt;Author info&lt;/p&gt;
      &lt;p&gt;publication date&lt;/p&gt;
    &lt;/footer&gt;
  &lt;/article&gt;
&lt;/section&gt;</pre>

<h3 id="Section_Element">Section Element</h3>

<p>The section element is used for a thematic grouping of content. Based on the W3C spec, a section should typically contain a heading. The heading does not require the use of the <code>&lt;header&gt;</code> element</p>

<pre>&lt;section&gt;
  &lt;h1&gt;Amazing MDN Contributors&lt;/h1&gt;
    &lt;ul&gt;
      &lt;li&gt;&lt;img src="link" alt="descriptive text"&gt;&lt;/li&gt;
      &lt;li&gt;&lt;img src="link" alt="descriptive text"&gt;&lt;/li&gt;
      &lt;li&gt;&lt;img src="link" alt="descriptive text"&gt;&lt;/li&gt;
    &lt;/ul&gt;
&lt;/section&gt;</pre>

<h3 id="Aside_Element">Aside Element</h3>

<p>The <code>&lt;aside&gt;</code> element defines related content that has a different placement than the main content. It is often used for call-outs, blockquotes, and definitions. The <code>&lt;aside&gt;</code> element is often used for sidebars containing extra, but relevant, information.</p>

<pre>&lt;section&gt;
  &lt;h1&gt;Amazing MDN Contributors&lt;/h1&gt;
    &lt;ul&gt;
      &lt;li&gt;&lt;img src="link" alt="descriptive text"&gt;&lt;/li&gt;
      &lt;li&gt;&lt;img src="link" alt="descriptive text"&gt;&lt;/li&gt;
      &lt;li&gt;&lt;img src="link" alt="descriptive text"&gt;&lt;/li&gt;
    &lt;/ul&gt;
    &lt;aside&gt;
     &lt;p&gt;To get involved contact&lt;/p&gt;
    &lt;/aside&gt;
&lt;/section&gt;</pre>

<h4 id="Nesting_Aside_Elements">Nesting Aside Elements</h4>

<p>The <code>&lt;aside&gt;</code> element can be nested inside of other sectional HTML elements. You do not nest an <code>&lt;aside&gt;</code> inside an <code>&lt;aside&gt;</code>. Meaning a call out box would not have a call-out box inside.</p>

<h2 id="Using_HTML5_elements_in_non-HTML5_browsers">Using HTML5 elements in non-HTML5 browsers</h2>

<p>Sections and headings elements can be made to work in most non-HTML5 browsers with a couple of extra steps, and in this section we'll show you how. If a significant percentage of your particular target audience is using Internet Explorer 8 or older, then you can follow the below instructions to make them behave as expected. However, global usage of these browsers is now very small, so this is unlikely.</p>

<p>HTML5 semantic elements don't need a special DOM interface, but they will need a specific CSS styling in older browser that don't support them explicitly. Unknown elements are styled as <code>display: inline</code> by default, so you'll want to set them to <code>display: block</code>:</p>

<pre class="brush: css">article, aside, footer, header, nav, section {
  display: block;
}
</pre>

<p>Of course the web developer can style them differently, but keep in mind that in a non-HTML5 browser, the default styling is different from what is expected for such elements. Also note that the {{HTMLElement("time")}} element has not been included, because the default styling for it in a non-HTML5 browser is the same as the one in an HTML5-compatible one.</p>

<p>Next up, older IE versions do not allow styling of unsupported elements, unless you create an instance of them in the DOM. You can add a specific script to allow this, as seen below:</p>

<pre class="brush:xml">&lt;!--[if lt IE 9]&gt;
  &lt;script&gt;
    document.createElement("article");
    document.createElement("aside");
    document.createElement("footer");
    document.createElement("header");
    document.createElement("nav");
    document.createElement("section");
    document.createElement("time");
  &lt;/script&gt;
&lt;![endif]--&gt;
</pre>

<p>As a last precaution, you could also add an explicit {{HTMLElement("noscript")}} element inside the {{HTMLElement("head")}} element to warn any users that have JavaScript disabled that your page relies on JavaScript:</p>

<pre class="brush:xml">&lt;noscript&gt;
  &lt;p&gt;&lt;strong&gt;This web page requires JavaScript to be enabled.&lt;/strong&gt;&lt;/p&gt;
  &lt;p&gt;JavaScript is an object-oriented computer programming language
    commonly used to create interactive effects within web browsers.&lt;/p&gt;
  &lt;p&gt;&lt;a href="https://goo.gl/koeeaJ"&gt;How to enable JavaScript?&lt;/a&gt;&lt;/p&gt;
&lt;/noscript&gt;
</pre>

<p>This leads to the following code to allow the support of the HTML5 sections and headings elements in non-HTML5 browsers, even for Internet Explorer (8 and older), with a proper fallback for the case where this latter browser is configured not to use scripting:</p>

<pre class="brush:xml">&lt;!--[if lt IE 9]&gt;
  &lt;script&gt;
    document.createElement("article");
    document.createElement("aside");
    document.createElement("footer");
    document.createElement("header");
    document.createElement("nav");
    document.createElement("section");
    document.createElement("time");
  &lt;/script&gt;
&lt;![endif]--&gt;
&lt;noscript&gt;
  &lt;p&gt;&lt;strong&gt;This web page requires JavaScript to be enabled.&lt;/strong&gt;&lt;/p&gt;
  &lt;p&gt;JavaScript is an object-oriented computer programming language
    commonly used to create interactive effects within web browsers.&lt;/p&gt;
  &lt;p&gt;&lt;a href="https://goo.gl/koeeaJ"&gt;How to enable JavaScript?&lt;/a&gt;&lt;/p&gt;
&lt;/noscript&gt;
</pre>

<div class="notecard note">
<p><strong>Note</strong>: This code will also cause the <a href="https://validator.w3.org/">HTML validator</a> to return errors. This isn't a really bad thing neccessarily — sites will often have a few validation errors — but it's something to be aware of still.</p>
</div>

<h2 id="Conclusion">Conclusion</h2>

<p>The new semantic elements introduced in HTML5 bring the ability to describe the structure of a web document in a standard way. They bring a big advantage for people having HTML5 browsers and needing the structure to help them understand the page, for instance people needing the help of some assistive technology. These new semantic elements are simple to use and, with very few burdens, can be made to work also in non-HTML5 browsers. Therefore they should be used without restrictions.</p>
